#include <stdlib.h>
#include <stdio.h>

int main()
{
    long N, K, i, p, min, minp;
    long A[500000];
    long M[500000];

    scanf("%li%li", &N, &K);

    for(i=0; i<N; i++)
    {
        scanf("%li", &A[i]);
        M[i] = 1;
    }

    p = -1;
    while(K>0)
    {
        min = A[p+1];
        minp = p + 1;
        for(i=p+2; i<=p+K+1; i++)
            if(A[i]<min)
            {
                min = A[i];
                minp = i;
            }

        for(i=p+1; i<minp; i++)
            M[i] = 0;

        K = K - (minp - p - 1);
        p = minp;
    }

    for(i = 0; i<N; i++)
        if(M[i]==1)
            printf("%li ", A[i]);

    return 0;
}